
/* lib/regex.js */

module.exports = {
  
  relPath: /^\.\//,
  absPath: /^\//,
  isPath: /\//g,
  jsFile: /\.js$/i,
  dotFile: /^\./,
  validRegex: new RegExp('^\\/\\^[^]{0,}\\$\\/'),
  singleParam: /^\/[^\/]{0,}$/,
  fileWithExtension: /\.[^\/\\ ]+$/,
  htmlFile: /\.htm(l)?$/i,
  hasSlash: /\//g,
  multipleSlashes: /[\/]{2,}/g,
  startsWithSlash: /^[\/]/,
  startsWithSlashes: /^[\/]+/,
  restrictedView: /^#\/?/,
  layoutView: /^@\/?/,
  startsWithUnderscore: /^_/,
  startOrEndSlash: /(^\/|\/$)/g,
  startOrEndRegex: /(^\^|\$$)/g,
  endingSlash: /\/$/,
  regExpChars: /(\^|\$|\\|\.|\*|\+|\?|\(|\)|\[|\]|\{|\}|\||\/)/g,
  controllerAlias: /^\/([^ \/]+)\//,
  integer: /^[0-9]+$/,
  float: /^\d+\.\d+$/,
  number: /^\d+(\.\d+)?$/,
  boolean: /^(true|false)$/i,
  binary: /^[01]+$/,
  binaryDigit: /^[01]$/,
  digit: /^\d$/,
  alpha: /^[a-z]+$/i,
  alpha_spaces: /^[a-z ]+$/i,
  alpha_dashes: /^[a-z\-]+$/i,
  alpha_underscores: /^[a-z_]+$/i,
  alpha_spaces_underscores: /^[a-z _]+$/i,
  alpha_dashes_underscores: /^[a-z\-_]+$/i,
  alpha_lower: /^[a-z]+$/,
  alpha_lower_spaces: /^[a-z ]+$/,
  alpha_lower_dashes: /^[a-z\-]+$/,
  alpha_lower_underscores: /^[a-z_]+$/,
  alpha_lower_spaces_underscores: /^[a-z _]+$/,
  alpha_lower_dashes_underscores: /^[a-z\-_]+$/,
  alpha_upper: /^[A-Z]+$/,
  alpha_upper_spaces: /^[A-Z ]+$/,
  alpha_upper_dashes: /^[A-Z\-]+$/,
  alpha_upper_underscores: /^[A-Z_]+$/,
  alpha_upper_spaces_underscores: /^[A-Z _]+$/,
  alpha_upper_dashes_underscores: /^[A-Z\-_]+$/,
  alnum: /^[a-z0-9]+$/i,
  alnum_spaces: /^[a-z0-9 ]+$/i,
  alnum_dashes: /^[a-z0-9\-]+$/i,
  alnum_underscores: /^[a-z0-9_]+$/i,
  alnum_spaces_underscores: /^[a-z0-9 _]+$/i,
  alnum_dashes_underscores: /^[a-z0-9\-_]+$/i,
  alnum_lower: /^[a-z0-9]+$/,
  alnum_lower_spaces: /^[a-z0-9 ]+$/,
  alnum_lower_dashes: /^[a-z0-9\-]+$/,
  alnum_lower_underscores: /^[a-z0-9_]+$/,
  alnum_lower_spaces_underscores: /^[a-z0-9 _]+$/,
  alnum_lower_dashes_underscores: /^[a-z0-9\-_]+$/,
  alnum_upper: /^[A-Z0-9]+$/,
  alnum_upper_spaces: /^[A-Z0-9 ]+$/,
  alnum_upper_dashes: /^[A-Z0-9\-]+$/,
  alnum_upper_underscores: /^[A-Z0-9_]+$/,
  alnum_upper_spaces_underscores: /^[A-Z0-9 _]+$/,
  alnum_upper_dashes_underscores: /^[A-Z0-9\-_]+$/,
  white_space: /^\s+$/g,
  variable: /^[a-z_$][a-z0-9_$]*$/i,
  checkbox: /^(|on)$/i,
  anything: /(.+|)/,
  something: /.+/,
  md5: /^[a-f0-9]{32}$/i,
  uuid: /^[a-f0-9]{8}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{12}$/i,
  url: /^(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?$/i,
  email: /^[_a-z0-9\-"'\/]+(\.[_a-z0-9\-"'\/]+)*@[a-z0-9\-]+(\.[a-z0-9\-]+)*\.(([0-9]{1,3})|([a-z]{2,3})|(aero|coop|info|museum|name|local|localhost))$/i,
  password: new RegExp('^[^]{6,30}$')
  
}